
// check if data can be created using one Layer method
public boolean isValidCNCOneLayer(OneLayerDataToSend input) {
 
  // start and end of drilling path coordinates 
  float x0 = input.getStrPosition().x;
  float y0 = input.getStrPosition().y;
  float z0 = input.getStrPosition().z;
  float x1 = input.getEndPosition().x;
  float y1 = input.getEndPosition().y;
  float z1 = input.getEndPosition().z;
  
  // dimensions of material should be specified
  if (CNCOneLayerTFLengthValue == 0 &&
      CNCOneLayerTFWidthValue == 0 && 
      CNCOneLayerTFHeightValue == 0) {
        return false;
  }
  
  // check base on its an fabrication or not
  if (CNCOneLayerAddt.getState()) {
    // z0 must be on the top of base material bottom surface
    if ((z0 <= 0)) {
          return false;
    }
    // end point must be inside the material   
    if ((x1 < 0 || x1 > CNCOneLayerTFLengthValue) ||
        (y1 < 0 || y1 > CNCOneLayerTFWidthValue) ||
        (z1 < 0 || z1 > CNCOneLayerTFHeightValue)) {
          return false;
    }    
  } else {
    // z0 must be on the top of base material
    if ((z0 < CNCOneLayerTFHeightValue)) {
          return false;
    }
    // start point must be outside the material
    if ((x0 > 0 && x0 < CNCOneLayerTFLengthValue) &&
        (y0 > 0 && y0 < CNCOneLayerTFWidthValue) &&
        (z0 > 0 && z0 < CNCOneLayerTFHeightValue)) {
          return false;
    }
    // end point must be inside the material   
    if ((x1 < 0 || x1 > CNCOneLayerTFLengthValue) ||
        (y1 < 0 || y1 > CNCOneLayerTFWidthValue) ||
        (z1 < 0 || z1 > CNCOneLayerTFHeightValue)) {
          return false;
    }
  }
  return true;

}

