///////////////////////////
// CNC One Layer Data Class
///////////////////////////

class CNCOneLayerData {
  private PVector position;
  private float magnitude;
  private float diameter;
  
  // Constructor
  public CNCOneLayerData(PVector position, float magnitude, float diameter) {
    this.position = position;
    this.magnitude = magnitude;
    this.diameter = diameter;
  }
  
  //// Mutators
  public void setPosition(PVector position) {
    this.position = position;
  }
  
  public void setMagnitude(float magnitude) {
    this.magnitude = magnitude;
  }
  
  public void setDiameter(float diameter) {
    this.diameter = diameter;
  }
  
  //// Accessors
  public PVector getPosition() {
    return this.position;
  }
  
  public float getMagnitude() {
    return this.magnitude;
  }
  
  public float getDiameter() {
    return this.diameter;
  }
  
  ////other methods
  public boolean equals(Object other) {
    if (other instanceof CNCOneLayerData) {
      return (this.position.x == ((CNCOneLayerData) other).getPosition().x &&
             this.position.y == ((CNCOneLayerData) other).getPosition().y &&
             this.position.z == ((CNCOneLayerData) other).getPosition().z &&
             this.diameter == ((CNCOneLayerData) other).getDiameter());
    }
    else {
      return false;
    }
  }
}

////////////////////////////////
// CNC Multiple Layer Data Class
////////////////////////////////

class CNCMltLayerData {
  private PVector position;
  private float magnitude;
  private float diameter;
  private float margin;
  private boolean isUpdated;
  
  // Constructor
  public CNCMltLayerData(PVector position, float magnitude, float diameter, float margin, boolean isUpdated) {
    this.position = position;
    this.magnitude = magnitude;
    this.diameter = diameter;
    this.margin = margin;
    this.isUpdated = isUpdated;
  }
  
  //// Mutators
  public void setPosition(PVector position) {
    this.position = position;
  }
  
  public void setMagnitude(float magnitude) {
    this.magnitude = magnitude;
  }
  
  public void setDiameter(float diameter) {
    this.diameter = diameter;
  }
  
  public void setMargin(float margin) {
    this.margin = margin;
  }
  
  public void setIsUpdated(boolean isUpdated) {
    this.isUpdated = isUpdated;
  }

  //// Accessors
  public PVector getPosition() {
    return this.position;
  }
  
  public float getMagnitude() {
    return this.magnitude;
  }
  
  public float getDiameter() {
    return this.diameter;
  }
  
  public float getMargin() {
    return this.margin;
  }
  
  public boolean getIsUpdated() {
    return this.isUpdated;
  }
}

/////////////////////////////
// Robot one Layer Data Class
/////////////////////////////

class RBTOneLayerData {
  private PVector position;
  private float magnitude;
  private float diameter;
  private float xAngle;
  private float yAngle;
  private boolean isUpdated;
  
  // Constructor
  public RBTOneLayerData(PVector position, float magnitude, float diameter, float xAngle, float yAngle, boolean isUpdated) {
    this.position = position;
    this.magnitude = magnitude;
    this.diameter = diameter;
    this.xAngle = xAngle;
    this.yAngle = yAngle;
    this.isUpdated = isUpdated;
  }
  
  //// Mutators
  public void setPosition(PVector position) {
    this.position = position;
  }
  
  public void setMagnitude(float magnitude) {
    this.magnitude = magnitude;
  }
  
  public void setDiameter(float diameter) {
    this.diameter = diameter;
  }
  
  public void setXAngle(float xAngle) {
    this.xAngle = xAngle;
  }
  
  public void setYAngle(float yAngle) {
    this.yAngle = yAngle;
  }
  
  public void setIsUpdated(boolean isUpdated) {
    this.isUpdated = isUpdated;
  }
  
  //// Accessors
  public PVector getPosition() {
    return this.position;
  }
  
  public float getMagnitude() {
    return this.magnitude;
  }
  
  public float getDiameter() {
    return this.diameter;
  }
  
  public float getXAngle() {
    return this.xAngle;
  }
  
  public float getYAngle() {
    return this.yAngle;
  }
  
  public boolean getIsUpdated() {
    return this.isUpdated;
  }
}

//////////////////////////////////
// Robot Multiple Layer Data Class
//////////////////////////////////

class RBTMltLayerData {
  private PVector position;
  private float magnitude;
  private float diameter;
  private float xAngle;
  private float yAngle;
  private float margin;
  private boolean isUpdated;
  
  // Constructor
  public RBTMltLayerData(PVector position, float magnitude, float diameter, float xAngle, float yAngle, float margin, boolean isUpdated) {
    this.position = position;
    this.magnitude = magnitude;
    this.diameter = diameter;
    this.xAngle = xAngle;
    this.yAngle = yAngle;
    this.margin = margin;
    this.isUpdated = isUpdated;
  }
  
  //// Mutators
  public void setPosition(PVector position) {
    this.position = position;
  }
  
  public void setMagnitude(float magnitude) {
    this.magnitude = magnitude;
  }
  
  public void setDiameter(float diameter) {
    this.diameter = diameter;
  }
  
  public void setXAngle(float xAngle) {
    this.xAngle = xAngle;
  }
  
  public void setYAngle(float yAngle) {
    this.yAngle = yAngle;
  }
  
  public void setMargin(float margin) {
    this.margin = margin;
  }
  
  public void setIsUpdated(boolean isUpdated) {
    this.isUpdated = isUpdated;
  }
  
  //// Accessors
  public PVector getPosition() {
    return this.position;
  }
  
  public float getMagnitude() {
    return this.magnitude;
  }
  
  public float getDiameter() {
    return this.diameter;
  }
  
  public float getXAngle() {
    return this.xAngle;
  }
  
  public float getYAngle() {
    return this.yAngle;
  }
  
  public float getMargin() {
    return this.margin;
  }
  
  public boolean getIsUpdated() {
    return this.isUpdated;
  }
}

