///////////////////////////////
// One Layer Data to Send Class
///////////////////////////////


class OneLayerDataToSend {
  private PVector position;
  private float magnitude;
  private float diameter;
  private float xAngle;
  private float yAngle;
  private boolean isValid;
  
  // Constructor
  public OneLayerDataToSend(PVector position, float magnitude, float diameter, float xAngle, float yAngle, boolean isValid) {
    this.position = position;
    this.magnitude = magnitude;
    this.diameter = diameter;
    this.xAngle = xAngle;
    this.yAngle = yAngle;
    this.isValid = isValid;
  }
  
  //// Mutators
  public void setPosition(PVector position) {
    this.position = position;
  }
  
  public void setMagnitude(float magnitude) {
    this.magnitude = magnitude;
  }
  
  public void setDiameter(float diameter) {
    this.diameter = diameter;
  }
  
  public void setXAngle(float xAngle) {
    this.xAngle = xAngle;
  }
  
  public void setYAngle(float yAngle) {
    this.yAngle = yAngle;
  }
  
  public void setIsValid(boolean isValid) {
    this.isValid = isValid;
  }
  
  //// Accessors
  public PVector getStrPosition() {
    return this.position;
  }
  
  public PVector getEndPosition() {
    PVector endPosition = new PVector(this.position.x,
                                      this.position.y,
                                      this.position.z - this.magnitude);
    return endPosition;
  }
  
  public float getMagnitude() {
    return this.magnitude;
  }
  
  public float getDiameter() {
    return this.diameter;
  }
  
  public float getXAngle() {
    return this.xAngle;
  }
  
  public float getYAngle() {
    return this.yAngle;
  }
  
  public boolean getIsValid() {
    return this.isValid;
  }
  
  ////other methods
  public boolean equals(Object other) {
    if (other instanceof OneLayerDataToSend) {
      return (this.position.x == ((OneLayerDataToSend) other).getStrPosition().x &&
             this.position.y == ((OneLayerDataToSend) other).getStrPosition().y &&
             this.position.z == ((OneLayerDataToSend) other).getStrPosition().z &&
             this.diameter == ((OneLayerDataToSend) other).getDiameter() &&
             this.xAngle == ((OneLayerDataToSend) other).getXAngle() &&
             this.yAngle == ((OneLayerDataToSend) other).getYAngle());
    }
    else {
      return false;
    }
  }
  
  public int hashCode() {
    return (int) (31 * (this.position.x * 1 + this.position.y * 10 + this.position.z * 100 + this.diameter * 1000 + this.xAngle * 10000 + this.yAngle * 100000));
  }
}











