///////////////////////
// data sending methods
///////////////////////

// this method send COLData to GrassHopper based on
private void sendCOLData(OneLayerDataToSend data) {
  String COLD = "";
  if (CNCOneLayerAddt.getState()) {
    COLD = "COL " + "ADD " + 
           " X0 " + data.getStrPosition().x +
           " Y0 " + data.getStrPosition().y +
           " Z0 " + data.getStrPosition().z +
           " X1 " + data.getEndPosition().x +
           " Y1 " + data.getEndPosition().y +
           " Z1 " + data.getEndPosition().z +
           " isValid: " + data.getIsValid();
  } else {
    COLD = "COL " + "SUB " + 
           " X0 " + data.getStrPosition().x +
           " Y0 " + data.getStrPosition().y +
           " Z0 " + data.getStrPosition().z +
           " X1 " + data.getEndPosition().x +
           " Y1 " + data.getEndPosition().y +
           " Z1 " + data.getEndPosition().z +
           " isValid: " + data.getIsValid();
  }
  udps.send(COLD, ip, port);
}

// this method send CMLData to GrassHopper based on
private void sendCMLData() {
}

// this method send ROLData to GrassHopper based on
private void sendROLData() {
}

// this method send RMLData to GrassHopper based on
private void sendRMLData() {
}

// this method write COLData to text file
private void writeCOLData() {
  // delay for alerting user the program is writing to file
  delay(1000);
  // create a new printer writer
  PrintWriter pw = null;
  // create a file to store base geometry data
  String fileName = "C:/temp/Main.txt";
  File file=new File(fileName);
  
  // calculate number of valid points in U direction
  int numPtsInUDir = floor(CNCOneLayerTFLengthValue / userClass.getStepSize()) + 1;
  int numPtsInVDir = floor(CNCOneLayerTFWidthValue / userClass.getStepSize()) + 1;
  
  // try writing base geometry data to file 
  try
  {
    pw = new PrintWriter(new FileWriter(fileName, false));
    // write base geometry data to file
    pw.println("DataType " + "COL" +
               " L " + CNCOneLayerTFLengthValue + 
               " W " + CNCOneLayerTFWidthValue + 
               " H " + CNCOneLayerTFHeightValue + 
               " U " + CNCOneLayerTFGridUValue +
               " V " + CNCOneLayerTFGridVValue +
               " numPtsInUDir " + numPtsInUDir +
               " numPtsInVDir " + numPtsInVDir +
               " isAdditive " + CNCOneLayerAddt.getState());
  }
  catch (IOException e) 
  { 
    e.printStackTrace(); // Dump and primitive exception handling...
  }
  finally
  {
    // close writen file
    if (pw != null)
    {
      pw.close();
    }
  }
  
  // create a new file for storing COLData 
  fileName = "C:/temp/COLData.txt";
  file=new File(fileName);  
  // try writing COLData to file
  try
  {
    String COLD;
    pw = new PrintWriter(new FileWriter(fileName, false));    
    // write each data in COLData to file
    for(OneLayerDataToSend curData : COLDataToSend) {
      // if drill path is out of base geomtry do not write it to the file
      if (curData.getStrPosition().x > CNCOneLayerTFLengthValue || curData.getStrPosition().x < 0 ||
          curData.getStrPosition().y > CNCOneLayerTFWidthValue || curData.getStrPosition().y < 0) {
      } else {
        // create data to send values
        float x0 = curData.getStrPosition().x;
        float y0 = curData.getStrPosition().y;
        float z0 = curData.getStrPosition().z;
        float x1 = curData.getEndPosition().x;
        float y1 = curData.getEndPosition().y;
        float z1 = curData.getEndPosition().z;
        // if data is in boundary and valid but z0 is above top surface
        // put it on top surface of base geometry
        if(curData.getIsValid() && z0 > CNCOneLayerTFHeightValue) {
          z0 = CNCOneLayerTFHeightValue;
        }
        // modify z0 and z1 values if the drill path is not valid 
        // base on it is an additive fabrication or a subtractive one
        if (!curData.getIsValid()) {
          if(CNCOneLayerAddt.getState()) {
            z0 = CNCOneLayerTFHeightValue;
            z1 = 0;
          } else {
            // if z1 is above base geomtry put it on top surface
            if (z1 > CNCOneLayerTFHeightValue) {
              z1 = CNCOneLayerTFHeightValue;
            // if z1 is below bottom surface and z0 is above top
            // surface put z1 on bottom surface
            } else if (z1 < 0 && z0 > CNCOneLayerTFHeightValue) {
              z1 = 0;
            // if z0 is below top surface put z0 and z1 on top surface
            } else if (z0 < CNCOneLayerTFHeightValue) {
              z0 = CNCOneLayerTFHeightValue;
              z1 = CNCOneLayerTFHeightValue;
            }
          }
        }
        // write COLD into the file
        COLD = "X0 " + x0 + " Y0 " + y0 + " Z0 " + z0 +
               " X1 " + x1 + " Y1 " + y1 + " Z1 " + z1;
        pw.println(COLD);
        
      }        
    }
  } 
  catch (IOException e) 
  { 
    e.printStackTrace(); // Dump and primitive exception handling...
  }
  finally
  {
    // close writen file
    if (pw != null)
    {
      pw.close();
    }
  }
}

// this method write CMLData to text file
private void writeCMLData() {
}

// this method write ROLData to text file
private void writeROLData() {
}

// this method write RMLData to text file
private void writeRMLData() {
}

