// this user class create drill points that simulate
// a mathematical surface which is similar to surface
// a drop of water creates when it hits water surface

class UserClass1 implements subfabricator {
  
  private HashSet<CNCOneLayerData> COLData = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataAdd = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataRemove = new HashSet<CNCOneLayerData>();
  private HashSet<CNCMltLayerData> CMLData = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataAdd = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataRemove = new HashSet<CNCMltLayerData>();
  private HashSet<RBTOneLayerData> ROLData = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataAdd = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataRemove = new HashSet<RBTOneLayerData>();
  private HashSet<RBTMltLayerData> RMLData = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataAdd = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataRemove = new HashSet<RBTMltLayerData>();
  private int numInXDir;
  private int numInYDir;
  private float stepSize;
  
  UserClass1(int numInXDir, int numInYDir, float stepSize) {
    this.numInXDir = numInXDir;
    this.numInYDir = numInYDir;
    this.stepSize = stepSize;
    float maxDis = numInXDir * numInXDir + numInYDir * numInYDir;
    for (float x = 0; x <= numInXDir; x += stepSize) {
      for (float y = 0; y <= numInYDir; y += stepSize) {
        PVector position = new PVector(x, y, 75 + 25 * cos(1000 / (1 + sqrt(pow((x - numInXDir / 2),2) + pow((y - numInYDir / 2),2)))) / (1 + sqrt(pow((x - numInXDir / 2)/5,2) + pow((y - numInYDir / 2)/5,2))));
        float magnitude = 2 * (position.z - 50);
        float diameter = 1;
        CNCOneLayerData curData = new CNCOneLayerData(position, magnitude, diameter);
        COLData.add(curData);
      }
    }
  }
  
  void doUpdate() {
  }
  
  int getNumInXDir() {
    return this.numInXDir;
  }
  
  int getNumInYDir() {
    return this.numInYDir;
  }
  
  float getStepSize() {
    return this.stepSize;
  }
  
  HashSet<CNCOneLayerData> CNCOneLayer() {
    return COLData;
  }
  
  HashSet<CNCOneLayerData> AddToCNCOneLayer() {
    return COLDataAdd;
  }
  
  HashSet<CNCOneLayerData> RemoveFromCNCOneLayer() {
    return COLDataRemove;
  }
  
  HashSet<CNCMltLayerData> CNCMltLayer() {
    return CMLData;
  }
  
  HashSet<CNCMltLayerData> AddToCNCMltLayer() {
    return CMLDataAdd;
  }
  
  HashSet<CNCMltLayerData> RemoveFromCNCMltLayer() {
    return CMLDataRemove;
  }
  
  HashSet<RBTOneLayerData> RBTOneLayer() {
    return ROLData;
  }
  
  HashSet<RBTOneLayerData> AddToRBTOneLayer() {
    return ROLDataAdd;
  }
  
  HashSet<RBTOneLayerData> RemoveFromRBTOneLayer() {
    return ROLDataRemove;
  }
  
  HashSet<RBTMltLayerData> RBTMltLayer() {
    return RMLData;
  }
  
  HashSet<RBTMltLayerData> AddToRBTMltLayer() {
    return RMLDataAdd;
  }
  
  HashSet<RBTMltLayerData> RemoveFromRBTMltLayer() {
    return RMLDataRemove;
  }
  
}
