// this class create drill points that simulates a bumpy version
// of an image based on pixels brightness, darker points make
// deeper holes in base material

class UserClass2 implements subfabricator {
  
  private HashSet<CNCOneLayerData> COLData = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataAdd = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataRemove = new HashSet<CNCOneLayerData>();
  private HashSet<CNCMltLayerData> CMLData = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataAdd = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataRemove = new HashSet<CNCMltLayerData>();
  private HashSet<RBTOneLayerData> ROLData = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataAdd = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataRemove = new HashSet<RBTOneLayerData>();
  private HashSet<RBTMltLayerData> RMLData = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataAdd = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataRemove = new HashSet<RBTMltLayerData>();
  private int numInXDir;
  private int numInYDir;
  private float stepSize;
  private PImage img;
  
  UserClass2() {
    // enter path to your image here
    img = loadImage("C:\\temp\\images\\wdrop.jpg");
    this.numInXDir = img.width;
    this.numInYDir = img.height;
    this.stepSize = 10;
    int cols = floor(this.numInXDir / stepSize);
    int rows = floor(this.numInYDir / stepSize);
    for (int i = 0; i < cols; i++) {
      for (int j = 0; j < rows; j++) {
        float x = i * stepSize + stepSize / 2; // x position
        float y = j * stepSize + stepSize / 2; // y position
        int loc = floor(x + y * numInXDir);           // Pixel array location       
        color c = img.pixels[loc];       // Grab the color
        // Calculate a z position as a function of mouseX and pixel brightness
        float z = (brightness(img.pixels[loc])) / 255 * 10;
        PVector position = new PVector(x, y, 20);
        float magnitude = z; 
        float diameter = 1;
        CNCOneLayerData curData = new CNCOneLayerData(position, magnitude, diameter);
        COLData.add(curData);

      }
    }
  }
  
  void doUpdate() {
  }
  
  int getNumInXDir() {
    return this.numInXDir;
  }
  
  int getNumInYDir() {
    return this.numInYDir;
  }
  
  float getStepSize() {
    return this.stepSize;
  }
  
  HashSet<CNCOneLayerData> CNCOneLayer() {
    return COLData;
  }
  
  HashSet<CNCOneLayerData> AddToCNCOneLayer() {
    return COLDataAdd;
  }
  
  HashSet<CNCOneLayerData> RemoveFromCNCOneLayer() {
    return COLDataRemove;
  }
  
  HashSet<CNCMltLayerData> CNCMltLayer() {
    return CMLData;
  }
  
  HashSet<CNCMltLayerData> AddToCNCMltLayer() {
    return CMLDataAdd;
  }
  
  HashSet<CNCMltLayerData> RemoveFromCNCMltLayer() {
    return CMLDataRemove;
  }
  
  HashSet<RBTOneLayerData> RBTOneLayer() {
    return ROLData;
  }
  
  HashSet<RBTOneLayerData> AddToRBTOneLayer() {
    return ROLDataAdd;
  }
  
  HashSet<RBTOneLayerData> RemoveFromRBTOneLayer() {
    return ROLDataRemove;
  }
  
  HashSet<RBTMltLayerData> RBTMltLayer() {
    return RMLData;
  }
  
  HashSet<RBTMltLayerData> AddToRBTMltLayer() {
    return RMLDataAdd;
  }
  
  HashSet<RBTMltLayerData> RemoveFromRBTMltLayer() {
    return RMLDataRemove;
  }
  
}
