// this class create drill points that in additive form simulates
// series of random sine curves with variable thickness from 0 in two ends
// to 20 in middle point


class UserClass5 implements subfabricator {
  
  private HashSet<CNCOneLayerData> COLData = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataAdd = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataRemove = new HashSet<CNCOneLayerData>();
  private HashSet<CNCMltLayerData> CMLData = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataAdd = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataRemove = new HashSet<CNCMltLayerData>();
  private HashSet<RBTOneLayerData> ROLData = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataAdd = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataRemove = new HashSet<RBTOneLayerData>();
  private HashSet<RBTMltLayerData> RMLData = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataAdd = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataRemove = new HashSet<RBTMltLayerData>();
  private int numInXDir;
  private int numInYDir;
  private float stepSize;
  
  UserClass5(int numInXDir, int numInYDir, float stepSize) {
    this.numInXDir = numInXDir;
    this.numInYDir = numInYDir;
    this.stepSize = stepSize;
    for (float x = 0; x < numInXDir; x += stepSize) {
      int randStart = (int) random(0, 100);
      for (float y = 0; y < numInYDir; y += stepSize) {
        float z = 15 + 5 * sin(map((y - randStart), 0, 100, 0, 2 * PI)) ;
        PVector position = new PVector(x, y, z);
        float magnitude = 10 * sin(map(y/ (numInYDir), 0 , 1, 0, PI));
        float diameter = 1;
        CNCOneLayerData curData = new CNCOneLayerData(position, magnitude, diameter);
        COLData.add(curData);
      }
    }
  }
  
  void doUpdate() {
  }
  
  int getNumInXDir() {
    return this.numInXDir;
  }
  
  int getNumInYDir() {
    return this.numInYDir;
  }
  
  float getStepSize() {
    return this.stepSize;
  }
  
  HashSet<CNCOneLayerData> CNCOneLayer() {
    return COLData;
  }
  
  HashSet<CNCOneLayerData> AddToCNCOneLayer() {
    return COLDataAdd;
  }
  
  HashSet<CNCOneLayerData> RemoveFromCNCOneLayer() {
    return COLDataRemove;
  }
  
  HashSet<CNCMltLayerData> CNCMltLayer() {
    return CMLData;
  }
  
  HashSet<CNCMltLayerData> AddToCNCMltLayer() {
    return CMLDataAdd;
  }
  
  HashSet<CNCMltLayerData> RemoveFromCNCMltLayer() {
    return CMLDataRemove;
  }
  
  HashSet<RBTOneLayerData> RBTOneLayer() {
    return ROLData;
  }
  
  HashSet<RBTOneLayerData> AddToRBTOneLayer() {
    return ROLDataAdd;
  }
  
  HashSet<RBTOneLayerData> RemoveFromRBTOneLayer() {
    return ROLDataRemove;
  }
  
  HashSet<RBTMltLayerData> RBTMltLayer() {
    return RMLData;
  }
  
  HashSet<RBTMltLayerData> AddToRBTMltLayer() {
    return RMLDataAdd;
  }
  
  HashSet<RBTMltLayerData> RemoveFromRBTMltLayer() {
    return RMLDataRemove;
  }
  
}
