// this class create drill points that simulates a drawing pad
// where user can start drawing by pressing 'd' and moving mouse
// and finish drawing by pressing any other key
// It is an example of how subfabricator can work in realtime mode

class UserClass6 implements subfabricator {
  
  private HashSet<CNCOneLayerData> COLData = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataAdd = new HashSet<CNCOneLayerData>();
  private HashSet<CNCOneLayerData> COLDataRemove = new HashSet<CNCOneLayerData>();
  private HashSet<CNCMltLayerData> CMLData = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataAdd = new HashSet<CNCMltLayerData>();
  private HashSet<CNCMltLayerData> CMLDataRemove = new HashSet<CNCMltLayerData>();
  private HashSet<RBTOneLayerData> ROLData = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataAdd = new HashSet<RBTOneLayerData>();
  private HashSet<RBTOneLayerData> ROLDataRemove = new HashSet<RBTOneLayerData>();
  private HashSet<RBTMltLayerData> RMLData = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataAdd = new HashSet<RBTMltLayerData>();
  private HashSet<RBTMltLayerData> RMLDataRemove = new HashSet<RBTMltLayerData>();
  private int numInXDir;
  private int numInYDir;
  private float stepSize;
  
  UserClass6(int numInXDir, int numInYDir, float stepSize) {
    this.numInXDir = numInXDir;
    this.numInYDir = numInYDir;
    this.stepSize = stepSize;
    for (float x = 0; x <= numInXDir; x += stepSize) {
      for (float y = 0; y <= numInYDir; y += stepSize) {
        PVector position = new PVector(x, y, max(numInXDir, numInYDir) / 10);
        float magnitude = 0.9 * (max(numInXDir, numInYDir) / 10);
        float diameter = 1;
        CNCOneLayerData curData = new CNCOneLayerData(position, magnitude, diameter);
        COLData.add(curData);
      }
    }
  }
  
  void doUpdate() {
    COLDataAdd.removeAll(COLDataAdd);
    COLDataRemove.removeAll(COLDataRemove);
    for (int i = -5; i < 6; i++) {
      for (int j = -5; j < 6; j++) {
        if (key == 'd' || key == 'D') {
          PVector position = new PVector(round(map(mouseX + i * stepSize, 0, width, 0, numInXDir)) *stepSize,
                                         round(map(mouseY + j * stepSize, 0, height, 0, numInYDir)) * stepSize,
                                         max(numInXDir, numInYDir) / 10);
          float magnitude = max(numInXDir, numInYDir) / 10 - max(numInXDir, numInYDir) / 20; 
          float diameter = 1;
          CNCOneLayerData curDataToRemove = new CNCOneLayerData(position, magnitude, diameter);
          CNCOneLayerData curDataToAdd = new CNCOneLayerData(position, magnitude, diameter);
          COLDataRemove.add(curDataToRemove);
          COLDataAdd.add(curDataToAdd);
        }
      }
    }
  }
  
  int getNumInXDir() {
    return this.numInXDir;
  }
  
  int getNumInYDir() {
    return this.numInYDir;
  }
  
  float getStepSize() {
    return this.stepSize;
  }
  
  HashSet<CNCOneLayerData> CNCOneLayer() {
    return COLData;
  }
  
  HashSet<CNCOneLayerData> AddToCNCOneLayer() {
    return COLDataAdd;
  }
  
  HashSet<CNCOneLayerData> RemoveFromCNCOneLayer() {
    return COLDataRemove;
  }
  
  HashSet<CNCMltLayerData> CNCMltLayer() {
    return CMLData;
  }
  
  HashSet<CNCMltLayerData> AddToCNCMltLayer() {
    return CMLDataAdd;
  }
  
  HashSet<CNCMltLayerData> RemoveFromCNCMltLayer() {
    return CMLDataRemove;
  }
  
  HashSet<RBTOneLayerData> RBTOneLayer() {
    return ROLData;
  }
  
  HashSet<RBTOneLayerData> AddToRBTOneLayer() {
    return ROLDataAdd;
  }
  
  HashSet<RBTOneLayerData> RemoveFromRBTOneLayer() {
    return ROLDataRemove;
  }
  
  HashSet<RBTMltLayerData> RBTMltLayer() {
    return RMLData;
  }
  
  HashSet<RBTMltLayerData> AddToRBTMltLayer() {
    return RMLDataAdd;
  }
  
  HashSet<RBTMltLayerData> RemoveFromRBTMltLayer() {
    return RMLDataRemove;
  }
  
}
